<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from builder.texi on 28 April 1999 -->

<TITLE>The Builder Library - Decl. Blocks</TITLE>
<link href="builder_32.html" rel=Next>
<link href="builder_30.html" rel=Previous>
<link href="builder_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_30.html">previous</A>, <A HREF="builder_32.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC62" HREF="builder_toc.html#TOC62">Block Operations and Initialization</A></H2>
<P>
<A NAME="IDX157"></A>

</P>
<P>
The <CODE>set_proc</CODE> function should be called before any use of builder
functions. The constructors and other functions are used to create and
compose blocks.  The <CODE>set</CODE> function is used to change the context
of a block to the new value. This is needed since the assignment
operator(<CODE>B = A</CODE>) does not perform the normal assignment operation.
The Assignment operator is overloaded to create a new block that will
perform an assignment in the resulting SUIF code.

</P>
<P>
<A NAME="IDX158"></A>
<A NAME="IDX159"></A>

<PRE>
    void set_proc(tree_proc * p)
<A NAME="IDX160"></A><A NAME="IDX161"></A>    tree_proc * get_proc()
<A NAME="IDX162"></A>
    block()           
    block(block * b)  
    block(block &#38; b)  
<A NAME="IDX163"></A><A NAME="IDX164"></A>    // Assignment
    void set(block * b)
    void set(block &#38; b)
<A NAME="IDX165"></A>    // Composition
    block(block &#38; ex1, block &#38; ex2, 
          block &#38; ex3 = *NOOP, block &#38; ex4 = *NOOP, 
          block &#38; ex5 = *NOOP, block &#38; ex6 = *NOOP, 
          block &#38; ex7 = *NOOP, block &#38; ex8 = *NOOP, 
          block &#38; ex9 = *NOOP, block &#38; ex10= *NOOP, 
          block &#38; ex11= *NOOP, block &#38; ex12= *NOOP)
<A NAME="IDX166"></A>     block &#38; statement(block &#38; ex1 = *NOOP, 
                       block &#38; ex2 = *NOOP, 
                       block &#38; ex3 = *NOOP, 
                       block &#38; ex4 = *NOOP, 
                       block &#38; ex5 = *NOOP, 
                       block &#38; ex6 = *NOOP, 
                       block &#38; ex7 = *NOOP, 
                       block &#38; ex8 = *NOOP, 
                       block &#38; ex9 = *NOOP, 
                       block &#38; ex10= *NOOP, 
                       block &#38; ex11= *NOOP, 
                       block &#38; ex12= *NOOP)  
<A NAME="IDX167"></A>     block &#38; statement_append(block &#38;)
<A NAME="IDX168"></A>     block &#38; statement_insert(block &#38;)
<A NAME="IDX169"></A>
    ~block();
</PRE>

<P><HR><P>
<p>Go to the <A HREF="builder_1.html">first</A>, <A HREF="builder_30.html">previous</A>, <A HREF="builder_32.html">next</A>, <A HREF="builder_47.html">last</A> section, <A HREF="builder_toc.html">table of contents</A>.
</BODY>
</HTML>
